
XIncludeFile "Map.pbi"
;Proprits et tat d'un bloc
Enumeration 
  #Rien      
  #Open     
  #Close     
  #Toggle    
  #Teleporte 
EndEnumeration

Enumeration 
  #Sound_Open
  #Sound_Close
  #Sound_Metal
  #Sound_Wood
  #Sound_Wood1
  #Sound_Switch ; Tlporte
  #SOUND_CRUSH77; Block cass 
  #SOUND_DOWN01 ; Perdu
  #SOUND_BATHOS ; Perdu 2
  #SOUND_NEONBELL ;Gagn
  #Sound_Exit
EndEnumeration
#NbMap=34

Structure s_Event
  Type.l         ; Rien=0 ; Open = 1 ; Close = 2 ; Toggle = 3 ; Teleporte = 4
  Bloc.i_Vecteur ; Coordonnnes sur la map du pont  actionner
  *Next.s_Event
EndStructure

Structure s_LibEvent
  NbEvent.l
  *Event.s_Event
EndStructure

Global MemSens.l ; Mmorise le dernier mouvement pour tomber en tournant dans le bon sens
Global Dim Event.s_LibEvent(#MaxMapX,#MaxMapZ)
Global Dim PassCode.s(#NbMap+1)
Global NewList AnimEvent.s_LibEvent()
Define.l i
Restore PassCode 
For i=1 To #NbMap
  Read PassCode(i)
Next i

;Ajoute l'animation d'un vnement  la liste
Macro ADD_ANIM_EVENT()
  AddElement(AnimEvent())
  AnimEvent()\NbEvent=1
  AnimEvent()\Event=*Ptr
EndMacro
          
;Calcul les positions occupes par le joueur sur la map
Macro POSITION_NORD_SUD()
  *Player\Bloc1\x = *Player\p\x / #Taille
  *Player\Bloc1\z = (*Player\p\z - #Taille2) / #Taille
  *Player\Bloc2\x = *Player\Bloc1\x
  *Player\Bloc2\z = (*Player\p\z + #Taille2) / #Taille
  If *Player\Taille=#Cube
    *Player\Bloc2\x = *Player\p2\x/#Taille
    *Player\Bloc2\z = *Player\p2\z/#Taille  
  EndIf  
EndMacro
Macro POSITION_EST_OUEST()
  *Player\Bloc1\x = (*Player\p\x - #Taille2) / #Taille
  *Player\Bloc1\z = *Player\p\z / #Taille
  *Player\Bloc2\x = (*Player\p\x + #Taille2) / #Taille
  *Player\Bloc2\z = *Player\Bloc1\z
  If *Player\Taille=#Cube
    *Player\Bloc2\x = *Player\p2\x/#Taille
    *Player\Bloc2\z = *Player\p2\z/#Taille  
  EndIf
EndMacro
Macro POSITION_VERTICALE()
  *Player\Bloc1\x = *Player\p\x / #Taille
  *Player\Bloc1\z = *Player\p\z / #Taille
  *Player\Bloc2\x = *Player\Bloc1\x
  *Player\Bloc2\z = *Player\Bloc1\z
  If *Player\Taille=#Cube
    *Player\Bloc2\x = *Player\p2\x/#Taille
    *Player\Bloc2\z = *Player\p2\z/#Taille  
  EndIf
EndMacro

Macro CHARGE_MAP()
  InitEvent(*Map)
  InitMap(*Map, *Player)
  LoadMap(*Map, *Player)   
  CreateMap(*Map, *Player)
  LoadEvent(*Map)
EndMacro  
Macro TEST_OUT(x1,z1,x2,z2)
  If x1 < 1 Or z1 < 1 Or x1 > *Map\SizeX Or z1 > *Map\SizeZ Or x2 < 1 Or z2 < 1 Or x2 > *Map\SizeX Or z2 > *Map\SizeZ 
    *Player\Out = #True
  ElseIf DataMap(x1,z1)\Type = #Vide Or DataMap(x2,z2)\Type = #Vide
    *Player\Out = #True
  EndIf
EndMacro  

Macro SOUND_MAP(Sound)
  If *Map\SoundToggle = #False 
    *Map\SoundToggle = #True
    PlaySound(Sound,2)
  EndIf  
EndMacro
Macro TELEPORTATION()
  If k=1

    ;Le rectangle monte
    Tombe = #Taille*8
    Repeat 
      tombe - 4
      MoveEntity(*Player\Entity, 0, 5, 0)
      MoveEntity(*Player\Entity2, 0, 5, 0)
      RenderWorld()
      FlipBuffers()    
    Until Tombe <= 0  
    *Player\Taille=#Cube
    *Player\p\x=*Ptr\Bloc\x*#Taille 
    *Player\p\z=*Ptr\Bloc\z*#Taille  
    MakeMesh(*Player)
  ElseIf k=2

    *Player\p2\x=*Ptr\Bloc\x*#Taille 
    *Player\p2\y=#Taille2
    *Player\p2\z=*Ptr\Bloc\z*#Taille 
    ; Et on descend avec deux cubes
    tombe = 100

    HideEntity(*Player\Entity2,0)
    EntityLocate(*Player\Entity2,*Player\p2\x,*Player\p2\y,*Player\p2\z)
    MoveEntity(*Player\Entity,0,100,0)
    MoveEntity(*Player\Entity2,0,100,0) 
    Repeat
      tombe - 5
      MoveEntity(*Player\Entity, 0, -5, 0)
      MoveEntity(*Player\Entity2, 0, -5, 0)
      RenderWorld()
      FlipBuffers()    
    Until Tombe <= 0

  EndIf


EndMacro

;-Declare
Declare GestionClavier(*Map.s_Map, *Player.s_Player)
Declare CloseBloc(*Map.s_Map,x,z)
Declare OpenBloc(*Map.s_Map,x,z)
Declare AnimationEvent(*Map.s_Map)
Declare DoEvent(*Map.s_Map, *Player.s_Player, x, z)
Declare LoadEvent(*Map.s_Map)
Declare Perdu(*Map.s_Map, *Player.s_Player)
Declare Gagne(*Map.s_Map, *Player.s_Player)
Declare ControleJeu(*Map.s_Map, *Player.s_Player)
Declare Animation(*Map.s_Map, *Player.s_Player)
Declare InitEvent(*Map.s_Map)

DataSection
PassCode:
Data.s "780464"
Data.s "290299"
Data.s "918660"
Data.s "520967"
Data.s "028431";5
Data.s "524383"
Data.s "189493"
Data.s "499707"
Data.s "074355"
Data.s "300590";10
Data.s "291709"
Data.s "958640"
Data.s "448106"
Data.s "210362"
Data.s "098598";15
Data.s "000241"
Data.s "683596"
Data.s "284933"
Data.s "119785"
Data.s "543019";20
Data.s "728724"
Data.s "987319"
Data.s "293486"
Data.s "088198"
Data.s "250453";25
Data.s "426329"
Data.s "660141"
Data.s "769721"
Data.s "691859"
Data.s "280351";30
Data.s "138620"
Data.s "879021"
Data.s "614955"
Data.s "343434"
EndDataSection
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 1
; Folding = --