XIncludeFile "Menu.pbi"

Procedure DisplayMenu(*Map.s_Map)
  Define i,Mini,Maxi,Choix=-1, Selection,Quit, PosX=Screen\Width+20
  Define TpsCode, Coul
  Define Curseur$, Code$, A$, Credit$
  Repeat
    ;Mise  jour de CoefSelonFPS pour tre dispo ds le lancement du jeu.
    CoefSelonFPS=60.0/Engine3DFrameRate(#PB_Engine3D_Current) 
    If CoefSelonFPS>3 : CoefSelonFPS=3:EndIf
    RenderWorld()
    
    ;Dbut de la section Menu
    ClearScreen($330000)
    
    ExamineMouse()
    ExamineKeyboard()
    Selection=-1
    StartDrawing(ScreenOutput())
    DrawingFont(FontID(#Comic))
    DrawingMode(#PB_2DDrawing_Transparent)
    ;Test si la souris passe sur le menu  
    For i=0 To 4
      Mini=(Screen\Width-TextWidth(TexteMenu(i)))/2
      Maxi=Mini+TextWidth(TexteMenu(i))
      If MouseX()>Mini And MouseX()<Maxi
        If MouseY()>Screen\Height_2+i*40 And MouseY()<Screen\Height_2+40+(i*40)
          Selection=i ; Position de la souris sur le menu
        EndIf 
      EndIf 
    Next i 
    If MouseButton(#PB_MouseButton_Left) And selection>-1 
      Choix=Selection ; Mmorise la dernire validation du joueur
    EndIf
    
    ;Actions en fonction du choix du joueur
    Select Choix
      Case #StartGame
        *Map\Level=1
        Quit=#True
      
      Case #LoadGame
        ;Test si le joueur clique sur Enter
        Mini=(Screen\Width-TextWidth("Enter"))/2
        Maxi=Mini+TextWidth("Enter")
        Coul=$FFFFFF
        If MouseX()>Mini And MouseX()<Maxi
          If MouseY()>Screen\Height-100 And MouseY()<Screen\Height-60
            Coul=$0000FF
          EndIf 
        EndIf
        If MouseButton(#PB_MouseButton_Left) And Coul=$0000FF
          For i=1 To #NbMap
            If Code$=PassCode(i)
              *Map\Level=i
              Quit=#True
              Break
            EndIf
          Next
        EndIf
        ;Saisi du mot de passe 
        If ElapsedMilliseconds()-TpsCode>200
          TpsCode=ElapsedMilliseconds()
          Curseur$="_"
        Else
           Curseur$=" "
        EndIf    

        If Len(Code$)<6
          A$ = KeyboardInkey()
          ;Rejette les caractres diffrents d'un chiffre
          If Asc(A$)>='0' And Asc(A$)<='9' 
            Code$ + A$ 
          EndIf
        Else
          Curseur$=""
        EndIf  
        ;Efface un caractre avec la touche Back space
        If KeyboardReleased(#PB_Key_Back)  
          Code$ = Left(Code$, Len(Code$)-1) 
        EndIf 
 
        DrawText(Screen\Width_2-150,Screen\Height-150,"Type passcode: "+Code$+Curseur$,$00FFFF)
        DrawText((Screen\Width-TextWidth("Enter"))/2,Screen\Height-100,"Enter",Coul)
      Case #ToggleSound
      Case #Credits
        Credit$="Created by Damien Clarke , DXinteractive, 21st june 2007 - Remake with PureBasic By Comtois September 2007"
        DrawText(PosX+2, Screen\Height-98,Credit$,$AA0000)
        DrawText(PosX, Screen\Height-100,Credit$,$FF0000)
        PosX - 2
        If PosX < -TextWidth(Credit$)+10
          Posx = Screen\Width + 20
        EndIf  
      Case #Exit
        Quit=#True
        End
    EndSelect
    
      ;Affiche le menu en permanence
      For i=0 To 4
        If i=Selection 
          FrontColor($0000FF) ; En rouge si la souris passe dessus
        Else  
          FrontColor($FFFFFF) ; Sinon en blanc
        EndIf      
        DrawText((Screen\Width-TextWidth(TexteMenu(i)))/2,Screen\Height_2+i*40,TexteMenu(i))
      Next i
    StopDrawing() 
    DisplayTransparentSprite(#Souris,MouseX(),MouseY()) 
    FlipBuffers()
    
  Until Quit  
EndProcedure
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 16
; FirstLine = 1
; Folding = -